import { Duration } from 'aws-cdk-lib';
import { CacheCookieBehavior, CacheHeaderBehavior, CachePolicy, CachePolicyProps, CacheQueryStringBehavior } from 'aws-cdk-lib/aws-cloudfront';
import { Construct } from 'constructs';
/**
 * Represents the configuration for a Cache Policy.
 */
export interface TmCachePolicyProps extends CachePolicyProps {
    cachePolicyName?: string;
    cookieBehavior?: CacheCookieBehavior;
    headerBehavior?: CacheHeaderBehavior;
    queryStringBehavior?: CacheQueryStringBehavior;
    enableAcceptEncodingBrotli?: boolean;
    enableAcceptEncodingGzip?: boolean;
    defaultTtl?: Duration;
    maxTtl?: Duration;
    minTtl?: Duration;
    additionalCookies?: string[];
    additionalHeaders?: string[];
    queryStrings?: string[];
}
export declare class TmCachePolicy extends CachePolicy {
    /**
       * The CachePolicy created by the construct.
       */
    constructor(scope: Construct, id: string, props: TmCachePolicyProps);
}
