import { Construct } from 'constructs';
export interface AwsManagedPrefixListProps {
    /**
       * Name of the aws managed prefix list.
       * See: https://docs.aws.amazon.com/vpc/latest/userguide/working-with-aws-managed-prefix-lists.html#available-aws-managed-prefix-lists
       * eg. com.amazonaws.global.cloudfront.origin-facing
       */
    readonly name: string;
}
export declare class AwsManagedPrefixList extends Construct {
    readonly prefixListId: string;
    constructor(scope: Construct, id: string, { name }: AwsManagedPrefixListProps);
}
