import * as ecs from 'aws-cdk-lib/aws-ecs';
import * as ecsPatterns from 'aws-cdk-lib/aws-ecs-patterns';
import * as events from 'aws-cdk-lib/aws-events';
import { Construct } from 'constructs';
export interface IIefsVolumes {
    name: string;
    path: string;
}
/**
 * Represents the configuration for an ecsPatterns.
 */
export interface TmApplicationLoadBalancedFargateServiceProps extends ecsPatterns.ApplicationLoadBalancedFargateServiceProps {
    /**
   * The number of cpu units used by the task.
   */
    /**
   * The number of cpu units used by the task.
   */
    /**
   * The amount (in MiB) of memory used by the task.
   */
    /**
   * The desired number of instantiations of the task definition to keep running on the service.
   */
    /**
  * The container port.
  */
    readonly containerPort?: number;
    /**
  * The certificate .
  */
    /**
  * The listener port.
  */
    /**
  * The minumun number od tasks.
  */
    readonly minTaskCount?: number;
    /**
  * The maximum number of task.
  */
    readonly maxTaskCount?: number;
    /**
  * Custom http header value.
  */
    readonly customHttpHeaderValue?: string;
    readonly buildContextPath: string;
    readonly buildDockerfile: string;
    readonly buildContainerArgs?: {
        [key: string]: string;
    };
    readonly secrets?: {
        [key: string]: ecs.Secret;
    };
    readonly scheduledTaskScheduleExpression?: events.Schedule;
    readonly scheduledTasksCommand?: string;
    readonly efsVolumes?: IIefsVolumes[];
}
export declare class TmApplicationLoadBalancedFargateService extends ecsPatterns.ApplicationLoadBalancedFargateService {
    constructor(scope: Construct, id: string, props: TmApplicationLoadBalancedFargateServiceProps);
}
