import * as ec2 from 'aws-cdk-lib/aws-ec2';
import { Construct } from 'constructs';
/**
 * Represents the configuration for a VPC.
 */
export interface TmVpcProps extends ec2.VpcProps {
    /**
     * The CIDR block for the VPC.
     */
    readonly rangeCidr: string;
    /**
     * The maximum number of availability zones to use for the VPC.
     */
    /**
     * The number of NAT gateways to create for the VPC.
     */
    /**
     * Indicates whether to enable the S3 endpoint for the VPC.
     */
    readonly enableEndpoints?: Array<string>;
}
/**
 * A VPC construct that creates a VPC with public and private subnets.
 */
export declare class TmVpcBase extends ec2.Vpc {
    /**
     * The VPC created by the construct.
     */
    constructor(scope: Construct, id: string, props: TmVpcProps);
    private tmAddGatewayEndpoint;
}
